/* brain.c generated by valac 0.34.3, the Vala compiler
 * generated from brain.vala, do not modify */

/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2010  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <pasang.h>
#include <float.h>
#include <math.h>


#define PASANG_TYPE_CUT_OFF (pasang_cut_off_get_type ())

#define PASANG_TYPE_BRAIN_SPEC (pasang_brain_spec_get_type ())
typedef struct _PasangBrainSpec PasangBrainSpec;

#define PASANG_TYPE_BRAIN (pasang_brain_get_type ())
#define PASANG_BRAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_BRAIN, PasangBrain))
#define PASANG_BRAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_BRAIN, PasangBrainClass))
#define PASANG_IS_BRAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_BRAIN))
#define PASANG_IS_BRAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_BRAIN))
#define PASANG_BRAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_BRAIN, PasangBrainClass))

typedef struct _PasangBrain PasangBrain;
typedef struct _PasangBrainClass PasangBrainClass;
typedef struct _PasangBrainPrivate PasangBrainPrivate;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _pasang_game_iterator_unref0(var) ((var == NULL) ? NULL : (var = (pasang_game_iterator_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	PASANG_CUT_OFF_MAX = 10000,
	PASANG_CUT_OFF_MIN = -10000
} PasangCutOff;

struct _PasangBrainSpec {
	gint thinking_time;
	gint thinking_depth;
	gint discernment;
};

struct _PasangBrain {
	GObject parent_instance;
	PasangBrainPrivate * priv;
};

struct _PasangBrainClass {
	GObjectClass parent_class;
};

struct _PasangBrainPrivate {
	glong ticket;
	GTimer* timer;
	PasangBrainSpec brain_spec;
	PasangGame* root;
	GThread* thinking_thread;
	GMutex mutex;
	GCond cond;
	gboolean exiting;
	gboolean stopping;
	gboolean thinking;
};


static gpointer pasang_brain_parent_class = NULL;

GType pasang_cut_off_get_type (void) G_GNUC_CONST;
GType pasang_brain_spec_get_type (void) G_GNUC_CONST;
PasangBrainSpec* pasang_brain_spec_dup (const PasangBrainSpec* self);
void pasang_brain_spec_free (PasangBrainSpec* self);
void pasang_brain_spec_init (PasangBrainSpec *self);
GType pasang_brain_get_type (void) G_GNUC_CONST;
#define PASANG_BRAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PASANG_TYPE_BRAIN, PasangBrainPrivate))
enum  {
	PASANG_BRAIN_DUMMY_PROPERTY
};
void pasang_brain_request_exit (PasangBrain* self);
PasangBrain* pasang_brain_new (void);
PasangBrain* pasang_brain_construct (GType object_type);
static void* pasang_brain_run (PasangBrain* self);
static gpointer _pasang_brain_run_gthread_func (gpointer self);
void pasang_brain_request_stop (PasangBrain* self);
void pasang_brain_request_think (PasangBrain* self, PasangGame* game, PasangBrainSpec* spec, glong* issued_ticked);
static PasangMove* pasang_brain_think (PasangBrain* self);
static gint pasang_brain_search (PasangBrain* self, gint ply, gint depth, gint max_time, gboolean* depth_reached, PasangGame* game, gint alpha, gint beta);
static PasangMove* pasang_brain_select_move_randomly (PasangBrain* self);
static void g_cclosure_user_marshal_VOID__LONG_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void pasang_brain_finalize (GObject* obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);


GType pasang_cut_off_get_type (void) {
	static volatile gsize pasang_cut_off_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_cut_off_type_id__volatile)) {
		static const GEnumValue values[] = {{PASANG_CUT_OFF_MAX, "PASANG_CUT_OFF_MAX", "max"}, {PASANG_CUT_OFF_MIN, "PASANG_CUT_OFF_MIN", "min"}, {0, NULL, NULL}};
		GType pasang_cut_off_type_id;
		pasang_cut_off_type_id = g_enum_register_static ("PasangCutOff", values);
		g_once_init_leave (&pasang_cut_off_type_id__volatile, pasang_cut_off_type_id);
	}
	return pasang_cut_off_type_id__volatile;
}


void pasang_brain_spec_init (PasangBrainSpec *self) {
#line 30 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	memset (self, 0, sizeof (PasangBrainSpec));
#line 31 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	(*self).thinking_time = 1;
#line 32 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	(*self).thinking_depth = 2;
#line 33 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	(*self).discernment = 2;
#line 141 "brain.c"
}


PasangBrainSpec* pasang_brain_spec_dup (const PasangBrainSpec* self) {
	PasangBrainSpec* dup;
#line 26 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	dup = g_new0 (PasangBrainSpec, 1);
#line 26 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	memcpy (dup, self, sizeof (PasangBrainSpec));
#line 26 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return dup;
#line 153 "brain.c"
}


void pasang_brain_spec_free (PasangBrainSpec* self) {
#line 26 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_free (self);
#line 160 "brain.c"
}


GType pasang_brain_spec_get_type (void) {
	static volatile gsize pasang_brain_spec_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_brain_spec_type_id__volatile)) {
		GType pasang_brain_spec_type_id;
		pasang_brain_spec_type_id = g_boxed_type_register_static ("PasangBrainSpec", (GBoxedCopyFunc) pasang_brain_spec_dup, (GBoxedFreeFunc) pasang_brain_spec_free);
		g_once_init_leave (&pasang_brain_spec_type_id__volatile, pasang_brain_spec_type_id);
	}
	return pasang_brain_spec_type_id__volatile;
}


/**
     * The brain thinks using its own thread so that the GUI remains responsive.
     */
static gpointer _pasang_brain_run_gthread_func (gpointer self) {
	gpointer result;
	result = pasang_brain_run ((PasangBrain*) self);
#line 92 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_object_unref (self);
#line 92 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return result;
#line 185 "brain.c"
}


PasangBrain* pasang_brain_construct (GType object_type) {
	PasangBrain * self = NULL;
	GThread* _tmp0_ = NULL;
#line 88 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self = (PasangBrain*) g_object_new (object_type, NULL);
#line 89 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->exiting = FALSE;
#line 90 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->stopping = FALSE;
#line 91 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->thinking = FALSE;
#line 92 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = g_thread_new ("thinking", _pasang_brain_run_gthread_func, g_object_ref (self));
#line 92 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_g_thread_unref0 (self->priv->thinking_thread);
#line 92 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->thinking_thread = _tmp0_;
#line 88 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return self;
#line 208 "brain.c"
}


PasangBrain* pasang_brain_new (void) {
#line 88 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return pasang_brain_construct (PASANG_TYPE_BRAIN);
#line 215 "brain.c"
}


/**
     * Request the thinking thread to exit. Wait for the request to be complied.
     */
static gpointer _g_thread_ref0 (gpointer self) {
#line 109 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return self ? g_thread_ref (self) : NULL;
#line 225 "brain.c"
}


void pasang_brain_request_exit (PasangBrain* self) {
	GThread* _tmp0_ = NULL;
	GThread* _tmp1_ = NULL;
#line 102 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (self != NULL);
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->exiting = TRUE;
#line 104 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->stopping = TRUE;
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_lock (&self->priv->mutex);
#line 240 "brain.c"
	{
#line 106 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->thinking = FALSE;
#line 107 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		g_cond_signal (&self->priv->cond);
#line 246 "brain.c"
	}
#line 108 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 109 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = self->priv->thinking_thread;
#line 109 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp1_ = _g_thread_ref0 (_tmp0_);
#line 109 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_thread_join (_tmp1_);
#line 256 "brain.c"
}


/**
     * Request the thinking thread to abandon on-going thinking. 
     * Wait for the request to be complied.
     */
void pasang_brain_request_stop (PasangBrain* self) {
#line 116 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (self != NULL);
#line 117 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->stopping = TRUE;
#line 118 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_lock (&self->priv->mutex);
#line 271 "brain.c"
	{
#line 119 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->stopping = FALSE;
#line 275 "brain.c"
	}
#line 120 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 279 "brain.c"
}


/**
     * Request thinking on a new game configuration, killing any
     * on-going thinking prior to that.
     * This function returns its result via an out argument because the
     * result has to be set within the critical block. This alternative won't work:
     *    issued_ticket = request_think (game, vp)  <-- error
     * because the assignment is done outside the critical region.
     */
void pasang_brain_request_think (PasangBrain* self, PasangGame* game, PasangBrainSpec* spec, glong* issued_ticked) {
	glong _vala_issued_ticked = 0L;
	PasangGame* _tmp0_ = NULL;
	PasangStage _tmp1_ = 0;
	PasangStage _tmp2_ = 0;
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (self != NULL);
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (game != NULL);
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (spec != NULL);
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = game;
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp1_ = pasang_game_get_stage (_tmp0_);
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp2_ = _tmp1_;
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_vala_return_if_fail (_tmp2_ != PASANG_STAGE_GAME_OVER, "game.stage != Stage.GAME_OVER");
#line 133 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->stopping = TRUE;
#line 134 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_lock (&self->priv->mutex);
#line 314 "brain.c"
	{
		PasangGame* _tmp3_ = NULL;
		PasangGame* _tmp4_ = NULL;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
		PasangBrainSpec _tmp7_ = {0};
#line 135 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->stopping = FALSE;
#line 136 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->thinking = TRUE;
#line 137 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp3_ = game;
#line 137 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp4_ = pasang_game_new_clone (_tmp3_);
#line 137 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_g_object_unref0 (self->priv->root);
#line 137 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->root = _tmp4_;
#line 138 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp5_ = self->priv->ticket;
#line 138 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->ticket = _tmp5_ + 1;
#line 138 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp6_ = self->priv->ticket;
#line 138 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_vala_issued_ticked = _tmp6_;
#line 139 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp7_ = *spec;
#line 139 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		self->priv->brain_spec = _tmp7_;
#line 140 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		g_cond_signal (&self->priv->cond);
#line 347 "brain.c"
	}
#line 141 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (issued_ticked) {
#line 131 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		*issued_ticked = _vala_issued_ticked;
#line 355 "brain.c"
	}
}


/**
     * The task for the thinking thread. To stop this thread, call request_exit.
     */
static void* pasang_brain_run (PasangBrain* self) {
	void* result = NULL;
#line 147 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	while (TRUE) {
#line 369 "brain.c"
		gboolean _tmp0_ = FALSE;
#line 148 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp0_ = self->priv->exiting;
#line 148 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		if (!(!_tmp0_)) {
#line 148 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			break;
#line 377 "brain.c"
		}
#line 149 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		g_mutex_lock (&self->priv->mutex);
#line 381 "brain.c"
		{
			gboolean _tmp1_ = FALSE;
			gboolean _tmp6_ = FALSE;
#line 150 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp1_ = self->priv->thinking;
#line 150 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (_tmp1_) {
#line 389 "brain.c"
				PasangMove* response = NULL;
				PasangMove* _tmp2_ = NULL;
				gboolean _tmp3_ = FALSE;
#line 151 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp2_ = pasang_brain_think (self);
#line 151 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				response = _tmp2_;
#line 152 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp3_ = self->priv->stopping;
#line 152 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!_tmp3_) {
#line 401 "brain.c"
					glong _tmp4_ = 0L;
					PasangMove* _tmp5_ = NULL;
#line 152 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp4_ = self->priv->ticket;
#line 152 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp5_ = response;
#line 152 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					g_signal_emit_by_name (self, "got-move-signal", _tmp4_, _tmp5_);
#line 410 "brain.c"
				}
#line 153 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				self->priv->thinking = FALSE;
#line 150 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_g_object_unref0 (response);
#line 416 "brain.c"
			}
#line 155 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp6_ = self->priv->exiting;
#line 155 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (!_tmp6_) {
#line 155 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				g_cond_wait (&self->priv->cond, &self->priv->mutex);
#line 424 "brain.c"
			}
		}
#line 156 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		g_mutex_unlock (&self->priv->mutex);
#line 429 "brain.c"
	}
#line 158 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	result = NULL;
#line 158 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return result;
#line 435 "brain.c"
}


/**
     * Perform iterative deepening, and then inject some randomness to 
     * the move selection.
     */
static PasangMove* pasang_brain_think (PasangBrain* self) {
	PasangMove* result = NULL;
	gint max_time = 0;
	PasangBrainSpec _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint max_ply = 0;
	PasangBrainSpec _tmp2_ = {0};
	gint _tmp3_ = 0;
	PasangGame* _tmp4_ = NULL;
	PasangGame* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	GTimer* _tmp15_ = NULL;
	PasangMove* _tmp48_ = NULL;
#line 165 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = self->priv->brain_spec;
#line 167 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp1_ = _tmp0_.thinking_time;
#line 167 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	max_time = _tmp1_;
#line 168 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp2_ = self->priv->brain_spec;
#line 168 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp3_ = _tmp2_.thinking_depth;
#line 168 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	max_ply = _tmp3_ * 2;
#line 171 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp4_ = self->priv->root;
#line 171 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	pasang_game_generate_moves (_tmp4_);
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp5_ = self->priv->root;
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp6_ = pasang_game_numMoves (_tmp5_);
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp6_ == 1) {
#line 480 "brain.c"
		PasangGame* _tmp7_ = NULL;
		PasangMove* _tmp8_ = NULL;
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp7_ = self->priv->root;
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp8_ = pasang_game_getMove (_tmp7_, 0);
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		result = _tmp8_;
#line 172 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		return result;
#line 491 "brain.c"
	}
	{
		PasangGameIterator* _move_it = NULL;
		PasangGame* _tmp9_ = NULL;
		PasangGameIterator* _tmp10_ = NULL;
		PasangMove* move = NULL;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp9_ = self->priv->root;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp10_ = pasang_game_iterator (_tmp9_);
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_move_it = _tmp10_;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		while (TRUE) {
#line 506 "brain.c"
			PasangGameIterator* _tmp11_ = NULL;
			PasangMove* _tmp12_ = NULL;
			PasangMove* _tmp13_ = NULL;
			PasangMove* _tmp14_ = NULL;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp11_ = _move_it;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp12_ = pasang_game_iterator_next_value (_tmp11_);
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			move = _tmp12_;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp13_ = move;
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (!(_tmp13_ != NULL)) {
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				break;
#line 525 "brain.c"
			}
#line 174 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp14_ = move;
#line 174 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			pasang_move_set_value (_tmp14_, (gint) PASANG_CUT_OFF_MIN);
#line 531 "brain.c"
		}
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_g_object_unref0 (move);
#line 173 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_pasang_game_iterator_unref0 (_move_it);
#line 537 "brain.c"
	}
#line 178 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp15_ = self->priv->timer;
#line 178 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_timer_reset (_tmp15_);
#line 543 "brain.c"
	{
		gint depth = 0;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		depth = 1;
#line 548 "brain.c"
		{
			gboolean _tmp16_ = FALSE;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp16_ = TRUE;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			while (TRUE) {
#line 555 "brain.c"
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				gboolean _tmp20_ = FALSE;
				gboolean _tmp21_ = FALSE;
				gboolean depth_reached = FALSE;
				PasangGame* _tmp46_ = NULL;
				gboolean _tmp47_ = FALSE;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!_tmp16_) {
#line 565 "brain.c"
					gint _tmp17_ = 0;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp17_ = depth;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					depth = _tmp17_ + 1;
#line 571 "brain.c"
				}
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp16_ = FALSE;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp18_ = depth;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp19_ = max_ply;
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 179 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 583 "brain.c"
				}
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp21_ = self->priv->stopping;
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (_tmp21_) {
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp20_ = TRUE;
#line 591 "brain.c"
				} else {
					GTimer* _tmp22_ = NULL;
					gdouble _tmp23_ = 0.0;
					gint _tmp24_ = 0;
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp22_ = self->priv->timer;
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp23_ = g_timer_elapsed (_tmp22_, NULL);
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp24_ = max_time;
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp20_ = _tmp23_ > ((gdouble) _tmp24_);
#line 604 "brain.c"
				}
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (_tmp20_) {
#line 181 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 610 "brain.c"
				}
#line 182 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				depth_reached = FALSE;
#line 614 "brain.c"
				{
					PasangGameIterator* _move_it = NULL;
					PasangGame* _tmp25_ = NULL;
					PasangGameIterator* _tmp26_ = NULL;
					PasangMove* move = NULL;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp25_ = self->priv->root;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp26_ = pasang_game_iterator (_tmp25_);
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_move_it = _tmp26_;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					while (TRUE) {
#line 628 "brain.c"
						PasangGameIterator* _tmp27_ = NULL;
						PasangMove* _tmp28_ = NULL;
						PasangMove* _tmp29_ = NULL;
						PasangGame* game = NULL;
						PasangGame* _tmp30_ = NULL;
						PasangGame* _tmp31_ = NULL;
						PasangGame* _tmp32_ = NULL;
						PasangMove* _tmp33_ = NULL;
						gint val = 0;
						gint _tmp34_ = 0;
						gint _tmp35_ = 0;
						PasangGame* _tmp36_ = NULL;
						gint _tmp37_ = 0;
						gboolean _tmp38_ = FALSE;
						gboolean _tmp39_ = FALSE;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp27_ = _move_it;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp28_ = pasang_game_iterator_next_value (_tmp27_);
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_g_object_unref0 (move);
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						move = _tmp28_;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp29_ = move;
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						if (!(_tmp29_ != NULL)) {
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							break;
#line 658 "brain.c"
						}
#line 188 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp30_ = self->priv->root;
#line 188 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp31_ = pasang_game_new_clone (_tmp30_);
#line 188 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						game = _tmp31_;
#line 189 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp32_ = game;
#line 189 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp33_ = move;
#line 189 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						pasang_game_perform (_tmp32_, _tmp33_, TRUE);
#line 190 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp34_ = depth;
#line 190 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp35_ = max_time;
#line 190 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp36_ = game;
#line 190 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp37_ = pasang_brain_search (self, 1, _tmp34_, _tmp35_, &depth_reached, _tmp36_, (gint) PASANG_CUT_OFF_MIN, (gint) PASANG_CUT_OFF_MAX);
#line 190 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						val = -_tmp37_;
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_tmp39_ = self->priv->stopping;
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						if (_tmp39_) {
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp38_ = TRUE;
#line 688 "brain.c"
						} else {
							GTimer* _tmp40_ = NULL;
							gdouble _tmp41_ = 0.0;
							gint _tmp42_ = 0;
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp40_ = self->priv->timer;
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp41_ = g_timer_elapsed (_tmp40_, NULL);
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp42_ = max_time;
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp38_ = _tmp41_ > ((gdouble) _tmp42_);
#line 701 "brain.c"
						}
#line 193 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						if (_tmp38_) {
#line 195 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_g_object_unref0 (game);
#line 195 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							break;
#line 709 "brain.c"
						} else {
							PasangMove* _tmp43_ = NULL;
							gint _tmp44_ = 0;
							gint32 _tmp45_ = 0;
#line 199 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp43_ = move;
#line 199 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp44_ = val;
#line 199 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							_tmp45_ = g_random_int_range ((gint32) 0, (gint32) 10);
#line 199 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
							pasang_move_set_value (_tmp43_, (_tmp44_ * 10) + _tmp45_);
#line 722 "brain.c"
						}
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
						_g_object_unref0 (game);
#line 726 "brain.c"
					}
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_g_object_unref0 (move);
#line 187 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_pasang_game_iterator_unref0 (_move_it);
#line 732 "brain.c"
				}
#line 202 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp46_ = self->priv->root;
#line 202 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				pasang_game_sort_moves (_tmp46_);
#line 205 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp47_ = depth_reached;
#line 205 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!_tmp47_) {
#line 205 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 744 "brain.c"
				}
			}
		}
	}
#line 207 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp48_ = pasang_brain_select_move_randomly (self);
#line 207 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	result = _tmp48_;
#line 207 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return result;
#line 755 "brain.c"
}


/**
     * Search to the given depth. Return evaluation.
     * Side effect: depth_reached set to true if ply == depth.
     */
static gint pasang_brain_search (PasangBrain* self, gint ply, gint depth, gint max_time, gboolean* depth_reached, PasangGame* game, gint alpha, gint beta) {
	gint result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp5_ = FALSE;
	PasangGame* _tmp6_ = NULL;
	PasangStage _tmp7_ = 0;
	PasangStage _tmp8_ = 0;
	gint _tmp46_ = 0;
#line 214 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_val_if_fail (game != NULL, 0);
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp1_ = self->priv->stopping;
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp1_) {
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp0_ = TRUE;
#line 782 "brain.c"
	} else {
		GTimer* _tmp2_ = NULL;
		gdouble _tmp3_ = 0.0;
		gint _tmp4_ = 0;
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp2_ = self->priv->timer;
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp4_ = max_time;
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp0_ = _tmp3_ > ((gdouble) _tmp4_);
#line 795 "brain.c"
	}
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp0_) {
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		result = 0;
#line 217 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		return result;
#line 803 "brain.c"
	}
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp6_ = game;
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp7_ = pasang_game_get_stage (_tmp6_);
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp8_ = _tmp7_;
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp8_ == PASANG_STAGE_GAME_OVER) {
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp5_ = TRUE;
#line 815 "brain.c"
	} else {
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp9_ = ply;
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp10_ = depth;
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp5_ = _tmp9_ == _tmp10_;
#line 825 "brain.c"
	}
#line 219 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp5_) {
#line 829 "brain.c"
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		PasangGame* _tmp13_ = NULL;
		gint* _tmp14_ = NULL;
		gint _tmp14__length1 = 0;
		PasangGame* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
		PasangGame* _tmp19_ = NULL;
		gint* _tmp20_ = NULL;
		gint _tmp20__length1 = 0;
		PasangGame* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
#line 220 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp11_ = ply;
#line 220 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp12_ = depth;
#line 220 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		if (_tmp11_ == _tmp12_) {
#line 220 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			*depth_reached = TRUE;
#line 854 "brain.c"
		}
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp13_ = game;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp14_ = _tmp13_->score;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp14__length1 = _tmp13_->score_length1;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp15_ = game;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp16_ = pasang_game_get_player (_tmp15_);
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp17_ = _tmp16_;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp18_ = _tmp14_[_tmp17_];
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp19_ = game;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp20_ = _tmp19_->score;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp20__length1 = _tmp19_->score_length1;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp21_ = game;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp22_ = pasang_game_get_player (_tmp21_);
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp23_ = _tmp22_;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp24_ = _tmp20_[1 - _tmp23_];
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		result = _tmp18_ - _tmp24_;
#line 221 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		return result;
#line 888 "brain.c"
	}
	{
		PasangGameIterator* _move_it = NULL;
		PasangGame* _tmp25_ = NULL;
		PasangGameIterator* _tmp26_ = NULL;
		PasangMove* move = NULL;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp25_ = game;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp26_ = pasang_game_iterator (_tmp25_);
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_move_it = _tmp26_;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		while (TRUE) {
#line 903 "brain.c"
			PasangGameIterator* _tmp27_ = NULL;
			PasangMove* _tmp28_ = NULL;
			PasangMove* _tmp29_ = NULL;
			PasangGame* game2 = NULL;
			PasangGame* _tmp30_ = NULL;
			PasangGame* _tmp31_ = NULL;
			PasangGame* _tmp32_ = NULL;
			PasangMove* _tmp33_ = NULL;
			gint val = 0;
			gint _tmp34_ = 0;
			gint _tmp35_ = 0;
			gint _tmp36_ = 0;
			PasangGame* _tmp37_ = NULL;
			gint _tmp38_ = 0;
			gint _tmp39_ = 0;
			gint _tmp40_ = 0;
			gint _tmp41_ = 0;
			gint _tmp42_ = 0;
			gint _tmp44_ = 0;
			gint _tmp45_ = 0;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp27_ = _move_it;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp28_ = pasang_game_iterator_next_value (_tmp27_);
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			move = _tmp28_;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp29_ = move;
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (!(_tmp29_ != NULL)) {
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				break;
#line 938 "brain.c"
			}
#line 225 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp30_ = game;
#line 225 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp31_ = pasang_game_new_clone (_tmp30_);
#line 225 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			game2 = _tmp31_;
#line 226 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp32_ = game2;
#line 226 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp33_ = move;
#line 226 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			pasang_game_perform (_tmp32_, _tmp33_, TRUE);
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp34_ = ply;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp35_ = depth;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp36_ = max_time;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp37_ = game2;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp38_ = beta;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp39_ = alpha;
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp40_ = pasang_brain_search (self, _tmp34_ + 1, _tmp35_, _tmp36_, depth_reached, _tmp37_, -_tmp38_, -_tmp39_);
#line 227 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			val = -_tmp40_;
#line 230 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp41_ = val;
#line 230 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp42_ = alpha;
#line 230 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (_tmp41_ > _tmp42_) {
#line 974 "brain.c"
				gint _tmp43_ = 0;
#line 230 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp43_ = val;
#line 230 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				alpha = _tmp43_;
#line 980 "brain.c"
			}
#line 231 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp44_ = alpha;
#line 231 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp45_ = beta;
#line 231 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (_tmp44_ > _tmp45_) {
#line 231 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_g_object_unref0 (game2);
#line 231 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				break;
#line 992 "brain.c"
			}
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (game2);
#line 996 "brain.c"
		}
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_g_object_unref0 (move);
#line 224 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_pasang_game_iterator_unref0 (_move_it);
#line 1002 "brain.c"
	}
#line 233 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp46_ = alpha;
#line 233 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	result = _tmp46_;
#line 233 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return result;
#line 1010 "brain.c"
}


/**
     * Provide some variability in the line of play.
     * Assume root's branches are sorted in descending values.
     */
static PasangMove* pasang_brain_select_move_randomly (PasangBrain* self) {
	PasangMove* result = NULL;
	PasangGame* _tmp0_ = NULL;
	PasangStage _tmp1_ = 0;
	PasangStage _tmp2_ = 0;
	gint smallest_value = 0;
	PasangGame* _tmp27_ = NULL;
	PasangGame* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	PasangMove* _tmp30_ = NULL;
	PasangMove* _tmp31_ = NULL;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	gint total = 0;
	gint num_rolls = 0;
	PasangBrainSpec _tmp45_ = {0};
	gint _tmp46_ = 0;
	PasangGame* _tmp47_ = NULL;
	PasangStage _tmp48_ = 0;
	PasangStage _tmp49_ = 0;
	gint roll = 0;
	gint _tmp54_ = 0;
	gint32 _tmp55_ = 0;
	PasangGame* _tmp76_ = NULL;
	PasangMove* _tmp77_ = NULL;
#line 241 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 242 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = self->priv->root;
#line 242 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp1_ = pasang_game_get_stage (_tmp0_);
#line 242 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp2_ = _tmp1_;
#line 242 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp2_ == PASANG_STAGE_OPENING) {
#line 1054 "brain.c"
		{
			PasangGameIterator* _move_it = NULL;
			PasangGame* _tmp3_ = NULL;
			PasangGameIterator* _tmp4_ = NULL;
			PasangMove* move = NULL;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp3_ = self->priv->root;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp4_ = pasang_game_iterator (_tmp3_);
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_move_it = _tmp4_;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			while (TRUE) {
#line 1068 "brain.c"
				PasangGameIterator* _tmp5_ = NULL;
				PasangMove* _tmp6_ = NULL;
				PasangMove* _tmp7_ = NULL;
				PasangMove* _tmp8_ = NULL;
				PasangMove* _tmp9_ = NULL;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp5_ = _move_it;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp6_ = pasang_game_iterator_next_value (_tmp5_);
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_g_object_unref0 (move);
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				move = _tmp6_;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp7_ = move;
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!(_tmp7_ != NULL)) {
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 1090 "brain.c"
				}
#line 245 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp8_ = move;
#line 245 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp9_ = move;
#line 245 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp10_ = pasang_move_get_value (_tmp9_);
#line 245 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp11_ = _tmp10_;
#line 245 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				pasang_move_set_value (_tmp9_, _tmp11_ / 10);
#line 1102 "brain.c"
			}
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 244 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_pasang_game_iterator_unref0 (_move_it);
#line 1108 "brain.c"
		}
	} else {
		gint discernment = 0;
		PasangBrainSpec _tmp12_ = {0};
		gint _tmp13_ = 0;
#line 250 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp12_ = self->priv->brain_spec;
#line 250 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp13_ = _tmp12_.discernment;
#line 250 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		discernment = (_tmp13_ - 1) * 5;
#line 1120 "brain.c"
		{
			PasangGameIterator* _move_it = NULL;
			PasangGame* _tmp14_ = NULL;
			PasangGameIterator* _tmp15_ = NULL;
			PasangMove* move = NULL;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp14_ = self->priv->root;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp15_ = pasang_game_iterator (_tmp14_);
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_move_it = _tmp15_;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			while (TRUE) {
#line 1134 "brain.c"
				PasangGameIterator* _tmp16_ = NULL;
				PasangMove* _tmp17_ = NULL;
				PasangMove* _tmp18_ = NULL;
				PasangMove* _tmp19_ = NULL;
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp16_ = _move_it;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp17_ = pasang_game_iterator_next_value (_tmp16_);
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_g_object_unref0 (move);
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				move = _tmp17_;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp18_ = move;
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!(_tmp18_ != NULL)) {
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 1155 "brain.c"
				}
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp19_ = move;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp20_ = pasang_move_get_value (_tmp19_);
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp21_ = _tmp20_;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (_tmp21_ > 0) {
#line 1165 "brain.c"
					PasangMove* _tmp22_ = NULL;
					PasangMove* _tmp23_ = NULL;
					gint _tmp24_ = 0;
					gint _tmp25_ = 0;
					gint _tmp26_ = 0;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp22_ = move;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp23_ = move;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp24_ = pasang_move_get_value (_tmp23_);
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp25_ = _tmp24_;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp26_ = discernment;
#line 252 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					pasang_move_set_value (_tmp23_, _tmp25_ + _tmp26_);
#line 1183 "brain.c"
				}
			}
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 251 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_pasang_game_iterator_unref0 (_move_it);
#line 1190 "brain.c"
		}
	}
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp27_ = self->priv->root;
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp28_ = self->priv->root;
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp29_ = pasang_game_numMoves (_tmp28_);
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp30_ = pasang_game_getMove (_tmp27_, _tmp29_ - 1);
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp31_ = _tmp30_;
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp32_ = pasang_move_get_value (_tmp31_);
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp33_ = _tmp32_;
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp34_ = _tmp33_;
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_g_object_unref0 (_tmp31_);
#line 257 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	smallest_value = _tmp34_;
#line 258 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	total = 0;
#line 1215 "brain.c"
	{
		PasangGameIterator* _move_it = NULL;
		PasangGame* _tmp35_ = NULL;
		PasangGameIterator* _tmp36_ = NULL;
		PasangMove* move = NULL;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp35_ = self->priv->root;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp36_ = pasang_game_iterator (_tmp35_);
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_move_it = _tmp36_;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		while (TRUE) {
#line 1229 "brain.c"
			PasangGameIterator* _tmp37_ = NULL;
			PasangMove* _tmp38_ = NULL;
			PasangMove* _tmp39_ = NULL;
			gint _tmp40_ = 0;
			PasangMove* _tmp41_ = NULL;
			gint _tmp42_ = 0;
			gint _tmp43_ = 0;
			gint _tmp44_ = 0;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp37_ = _move_it;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp38_ = pasang_game_iterator_next_value (_tmp37_);
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			move = _tmp38_;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp39_ = move;
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (!(_tmp39_ != NULL)) {
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				break;
#line 1252 "brain.c"
			}
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp40_ = total;
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp41_ = move;
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp42_ = pasang_move_get_value (_tmp41_);
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp43_ = _tmp42_;
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp44_ = smallest_value;
#line 260 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			total = _tmp40_ + ((_tmp43_ - _tmp44_) + 1);
#line 1266 "brain.c"
		}
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_g_object_unref0 (move);
#line 259 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_pasang_game_iterator_unref0 (_move_it);
#line 1272 "brain.c"
	}
#line 263 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp45_ = self->priv->brain_spec;
#line 263 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp46_ = _tmp45_.discernment;
#line 263 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	num_rolls = _tmp46_;
#line 265 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp47_ = self->priv->root;
#line 265 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp48_ = pasang_game_get_stage (_tmp47_);
#line 265 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp49_ = _tmp48_;
#line 265 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (_tmp49_ == PASANG_STAGE_OPENING) {
#line 265 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		num_rolls = 1;
#line 1290 "brain.c"
	} else {
		PasangGame* _tmp50_ = NULL;
		PasangStage _tmp51_ = 0;
		PasangStage _tmp52_ = 0;
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp50_ = self->priv->root;
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp51_ = pasang_game_get_stage (_tmp50_);
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp52_ = _tmp51_;
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		if (_tmp52_ == PASANG_STAGE_SELECT) {
#line 1303 "brain.c"
			gint _tmp53_ = 0;
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp53_ = num_rolls;
#line 266 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			num_rolls = _tmp53_ / 2;
#line 1309 "brain.c"
		}
	}
#line 267 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp54_ = total;
#line 267 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp55_ = g_random_int_range ((gint32) 0, (gint32) _tmp54_);
#line 267 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	roll = (gint) _tmp55_;
#line 1318 "brain.c"
	{
		gint i = 0;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		i = 1;
#line 1323 "brain.c"
		{
			gboolean _tmp56_ = FALSE;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp56_ = TRUE;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			while (TRUE) {
#line 1330 "brain.c"
				gint _tmp58_ = 0;
				gint _tmp59_ = 0;
				gint roll2 = 0;
				gint _tmp60_ = 0;
				gint32 _tmp61_ = 0;
				gint _tmp62_ = 0;
				gint _tmp63_ = 0;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!_tmp56_) {
#line 1340 "brain.c"
					gint _tmp57_ = 0;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp57_ = i;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					i = _tmp57_ + 1;
#line 1346 "brain.c"
				}
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp56_ = FALSE;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp58_ = i;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp59_ = num_rolls;
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (!(_tmp58_ < _tmp59_)) {
#line 268 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					break;
#line 1358 "brain.c"
				}
#line 269 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp60_ = total;
#line 269 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp61_ = g_random_int_range ((gint32) 0, (gint32) _tmp60_);
#line 269 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				roll2 = (gint) _tmp61_;
#line 270 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp62_ = roll;
#line 270 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_tmp63_ = roll2;
#line 270 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				if (_tmp62_ > _tmp63_) {
#line 1372 "brain.c"
					gint _tmp64_ = 0;
#line 270 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					_tmp64_ = roll2;
#line 270 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
					roll = _tmp64_;
#line 1378 "brain.c"
				}
			}
		}
	}
	{
		PasangGameIterator* _move_it = NULL;
		PasangGame* _tmp65_ = NULL;
		PasangGameIterator* _tmp66_ = NULL;
		PasangMove* move = NULL;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp65_ = self->priv->root;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_tmp66_ = pasang_game_iterator (_tmp65_);
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_move_it = _tmp66_;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		while (TRUE) {
#line 1396 "brain.c"
			PasangGameIterator* _tmp67_ = NULL;
			PasangMove* _tmp68_ = NULL;
			PasangMove* _tmp69_ = NULL;
			gint _tmp70_ = 0;
			PasangMove* _tmp71_ = NULL;
			gint _tmp72_ = 0;
			gint _tmp73_ = 0;
			gint _tmp74_ = 0;
			gint _tmp75_ = 0;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp67_ = _move_it;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp68_ = pasang_game_iterator_next_value (_tmp67_);
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_g_object_unref0 (move);
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			move = _tmp68_;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp69_ = move;
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (!(_tmp69_ != NULL)) {
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				break;
#line 1420 "brain.c"
			}
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp70_ = roll;
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp71_ = move;
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp72_ = pasang_move_get_value (_tmp71_);
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp73_ = _tmp72_;
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp74_ = smallest_value;
#line 274 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			roll = _tmp70_ - ((_tmp73_ - _tmp74_) + 1);
#line 275 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			_tmp75_ = roll;
#line 275 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
			if (_tmp75_ < 0) {
#line 275 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				result = move;
#line 275 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				_pasang_game_iterator_unref0 (_move_it);
#line 275 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
				return result;
#line 1444 "brain.c"
			}
		}
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_g_object_unref0 (move);
#line 273 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		_pasang_game_iterator_unref0 (_move_it);
#line 1451 "brain.c"
	}
#line 277 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp76_ = self->priv->root;
#line 277 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp77_ = pasang_game_getMove (_tmp76_, 0);
#line 277 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	result = _tmp77_;
#line 277 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	return result;
#line 1461 "brain.c"
}


static void g_cclosure_user_marshal_VOID__LONG_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__LONG_OBJECT) (gpointer data1, glong arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__LONG_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_return_if_fail (n_param_values == 3);
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		data1 = closure->data;
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		data2 = param_values->data[0].v_pointer;
#line 1480 "brain.c"
	} else {
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		data1 = param_values->data[0].v_pointer;
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
		data2 = closure->data;
#line 1486 "brain.c"
	}
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	callback = (GMarshalFunc_VOID__LONG_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	callback (data1, g_value_get_long (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1492 "brain.c"
}


static void pasang_brain_class_init (PasangBrainClass * klass) {
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	pasang_brain_parent_class = g_type_class_peek_parent (klass);
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_type_class_add_private (klass, sizeof (PasangBrainPrivate));
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	G_OBJECT_CLASS (klass)->finalize = pasang_brain_finalize;
#line 1503 "brain.c"
	/**
	     * After the non-blocking request_think(game, vp, out ticket), the client will be 
	     * notified using this signal. The client should ensure that the ticket sent by the
	     * signal matches the ticket issued by request_think.
	     */
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_signal_new ("got_move_signal", PASANG_TYPE_BRAIN, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__LONG_OBJECT, G_TYPE_NONE, 2, G_TYPE_LONG, PASANG_TYPE_MOVE);
#line 1511 "brain.c"
}


static void pasang_brain_instance_init (PasangBrain * self) {
	GTimer* _tmp0_ = NULL;
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv = PASANG_BRAIN_GET_PRIVATE (self);
#line 48 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->ticket = (glong) 0;
#line 53 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_tmp0_ = g_timer_new ();
#line 53 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self->priv->timer = _tmp0_;
#line 67 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_mutex_init (&self->priv->mutex);
#line 68 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	g_cond_init (&self->priv->cond);
#line 1529 "brain.c"
}


static void pasang_brain_finalize (GObject* obj) {
	PasangBrain * self;
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PASANG_TYPE_BRAIN, PasangBrain);
#line 96 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	pasang_brain_request_exit (self);
#line 53 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 63 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_g_object_unref0 (self->priv->root);
#line 66 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_g_thread_unref0 (self->priv->thinking_thread);
#line 67 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 68 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	_vala_clear_GCond (&self->priv->cond);
#line 37 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/brain.vala"
	G_OBJECT_CLASS (pasang_brain_parent_class)->finalize (obj);
#line 1551 "brain.c"
}


GType pasang_brain_get_type (void) {
	static volatile gsize pasang_brain_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_brain_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PasangBrainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pasang_brain_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasangBrain), 0, (GInstanceInitFunc) pasang_brain_instance_init, NULL };
		GType pasang_brain_type_id;
		pasang_brain_type_id = g_type_register_static (G_TYPE_OBJECT, "PasangBrain", &g_define_type_info, 0);
		g_once_init_leave (&pasang_brain_type_id__volatile, pasang_brain_type_id);
	}
	return pasang_brain_type_id__volatile;
}


static void _vala_clear_GMutex (GMutex * mutex) {
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}


static void _vala_clear_GRecMutex (GRecMutex * mutex) {
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}


static void _vala_clear_GRWLock (GRWLock * mutex) {
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}


static void _vala_clear_GCond (GCond * mutex) {
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}



