/* game-series.c generated by valac 0.34.3, the Vala compiler
 * generated from game-series.vala, do not modify */

/*  Pasang Emas. Enjoy a unique traditional game of Brunei.
    Copyright (C) 2010  Nor Jaidi Tuah

    This file is part of Pasang Emas.
      
    Pasang Emas is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <pasang.h>
#include <stdlib.h>
#include <string.h>


#define PASANG_TYPE_GAME_SERIES (pasang_game_series_get_type ())
#define PASANG_GAME_SERIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PASANG_TYPE_GAME_SERIES, PasangGameSeries))
#define PASANG_GAME_SERIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PASANG_TYPE_GAME_SERIES, PasangGameSeriesClass))
#define PASANG_IS_GAME_SERIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PASANG_TYPE_GAME_SERIES))
#define PASANG_IS_GAME_SERIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PASANG_TYPE_GAME_SERIES))
#define PASANG_GAME_SERIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PASANG_TYPE_GAME_SERIES, PasangGameSeriesClass))

typedef struct _PasangGameSeries PasangGameSeries;
typedef struct _PasangGameSeriesClass PasangGameSeriesClass;
typedef struct _PasangGameSeriesPrivate PasangGameSeriesPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PasangGameSeries {
	PasangGame parent_instance;
	PasangGameSeriesPrivate * priv;
	gboolean rotated;
	gint num_wins[2];
	gint num_rounds;
};

struct _PasangGameSeriesClass {
	PasangGameClass parent_class;
};

struct _PasangGameSeriesPrivate {
	gchar** recording;
	gint recording_length1;
	gint _recording_size_;
	gint undo_num_wins[2];
	gint undo_num_rounds;
};


static gpointer pasang_game_series_parent_class = NULL;

GType pasang_game_series_get_type (void) G_GNUC_CONST;
#define PASANG_GAME_SERIES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PASANG_TYPE_GAME_SERIES, PasangGameSeriesPrivate))
enum  {
	PASANG_GAME_SERIES_DUMMY_PROPERTY
};
void pasang_game_series_start_new_series (PasangGameSeries* self);
void pasang_game_series_update_num_wins (PasangGameSeries* self);
void pasang_game_series_start_recorded (PasangGameSeries* self, const gchar* starting_pattern);
void pasang_game_series_perform_recorded (PasangGameSeries* self, PasangMove* move, gboolean full_move);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
void pasang_game_series_undo (PasangGameSeries* self);
gchar* pasang_game_series_starting_pattern (PasangGameSeries* self);
PasangGameSeries* pasang_game_series_new (void);
PasangGameSeries* pasang_game_series_construct (GType object_type);
static void pasang_game_series_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
     * Start a new series of games rounds
     */
void pasang_game_series_start_new_series (PasangGameSeries* self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 49 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (self != NULL);
#line 50 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->num_rounds = 0;
#line 51 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->num_wins[0] = 0;
#line 51 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = self->num_wins[0];
#line 52 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->num_wins[1] = 0;
#line 52 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = self->num_wins[1];
#line 106 "game-series.c"
}


/**
     * Update the number of wins. Must be called once only after each move
     */
void pasang_game_series_update_num_wins (PasangGameSeries* self) {
	PasangStage _tmp0_ = 0;
	PasangStage _tmp1_ = 0;
#line 58 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (self != NULL);
#line 59 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = pasang_game_get_stage ((PasangGame*) self);
#line 59 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = _tmp0_;
#line 59 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp1_ == PASANG_STAGE_GAME_OVER) {
#line 124 "game-series.c"
		gint _tmp2_ = 0;
		gint _tmp3_ = 0;
		gboolean _tmp4_ = FALSE;
		gint top = 0;
		gint bottom = 0;
		gint _tmp5_ = 0;
		gint diff = 0;
		gint* _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
#line 60 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp2_ = self->num_rounds;
#line 60 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		self->num_rounds = _tmp2_ + 1;
#line 62 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp4_ = self->rotated;
#line 62 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		if (_tmp4_) {
#line 62 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			_tmp3_ = 1;
#line 151 "game-series.c"
		} else {
#line 62 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			_tmp3_ = 0;
#line 155 "game-series.c"
		}
#line 62 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		top = _tmp3_;
#line 63 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp5_ = top;
#line 63 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		bottom = 1 - _tmp5_;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp6_ = ((PasangGame*) self)->score;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp6__length1 = ((PasangGame*) self)->score_length1;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp7_ = top;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp8_ = _tmp6_[_tmp7_];
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp9_ = ((PasangGame*) self)->score;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp9__length1 = ((PasangGame*) self)->score_length1;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp10_ = bottom;
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp11_ = _tmp9_[_tmp10_];
#line 64 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		diff = _tmp8_ - _tmp11_;
#line 65 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp12_ = diff;
#line 65 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		if (_tmp12_ > 0) {
#line 185 "game-series.c"
			gint _tmp13_ = 0;
#line 65 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			_tmp13_ = self->num_wins[0];
#line 65 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			self->num_wins[0] = _tmp13_ + 1;
#line 191 "game-series.c"
		} else {
			gint _tmp14_ = 0;
#line 66 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			_tmp14_ = diff;
#line 66 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			if (_tmp14_ < 0) {
#line 198 "game-series.c"
				gint _tmp15_ = 0;
#line 66 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp15_ = self->num_wins[1];
#line 66 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				self->num_wins[1] = _tmp15_ + 1;
#line 204 "game-series.c"
			}
		}
	}
}


/**
     * Start a game and record its starting pattern
     */
void pasang_game_series_start_recorded (PasangGameSeries* self, const gchar* starting_pattern) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gint _tmp4_ = 0;
#line 73 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (self != NULL);
#line 73 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (starting_pattern != NULL);
#line 74 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = starting_pattern;
#line 74 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	pasang_game_start ((PasangGame*) self, _tmp0_);
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = starting_pattern;
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp3_[0] = _tmp2_;
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording = (_vala_array_free (self->priv->recording, self->priv->recording_length1, (GDestroyNotify) g_free), NULL);
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording = _tmp3_;
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording_length1 = 1;
#line 75 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->_recording_size_ = self->priv->recording_length1;
#line 76 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp4_ = self->num_rounds;
#line 76 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->undo_num_rounds = _tmp4_;
#line 77 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	memcpy (self->priv->undo_num_wins, self->num_wins, 2 * sizeof (gint));
#line 250 "game-series.c"
}


/**
     * Perform a move and record it
     */
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if ((*length) == (*size)) {
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 264 "game-series.c"
	}
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	(*array)[(*length)++] = value;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	(*array)[*length] = NULL;
#line 270 "game-series.c"
}


void pasang_game_series_perform_recorded (PasangGameSeries* self, PasangMove* move, gboolean full_move) {
	PasangMove* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	PasangStage _tmp3_ = 0;
	PasangStage _tmp4_ = 0;
#line 83 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (self != NULL);
#line 83 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (move != NULL);
#line 84 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = move;
#line 84 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = full_move;
#line 84 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	pasang_game_perform ((PasangGame*) self, _tmp0_, _tmp1_);
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp3_ = pasang_game_get_stage ((PasangGame*) self);
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp4_ = _tmp3_;
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp4_ != PASANG_STAGE_SUB_MOVE) {
#line 296 "game-series.c"
		PasangStage _tmp5_ = 0;
		PasangStage _tmp6_ = 0;
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp5_ = pasang_game_get_stage ((PasangGame*) self);
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp6_ = _tmp5_;
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp2_ = _tmp6_ != PASANG_STAGE_SUB_SELECT;
#line 305 "game-series.c"
	} else {
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp2_ = FALSE;
#line 309 "game-series.c"
	}
#line 85 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp2_) {
#line 313 "game-series.c"
		gchar** _tmp7_ = NULL;
		gint _tmp7__length1 = 0;
		PasangMove* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp7_ = self->priv->recording;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp7__length1 = self->priv->recording_length1;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp8_ = move;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp9_ = pasang_move_get_notation (_tmp8_);
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp10_ = _tmp9_;
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 86 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_vala_array_add1 (&self->priv->recording, &self->priv->recording_length1, &self->priv->_recording_size_, _tmp11_);
#line 334 "game-series.c"
	}
}


/**
     * Undo a move (by replaying the game)
     */
void pasang_game_series_undo (PasangGameSeries* self) {
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PasangStage _tmp4_ = 0;
	PasangStage _tmp5_ = 0;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	const gchar* _tmp10_ = NULL;
#line 93 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_if_fail (self != NULL);
#line 93 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = self->priv->recording;
#line 93 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0__length1 = self->priv->recording_length1;
#line 93 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_vala_return_if_fail (_tmp0__length1 > 0, "recording.length > 0");
#line 95 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = self->priv->recording;
#line 95 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1__length1 = self->priv->recording_length1;
#line 95 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp1__length1 == 1) {
#line 95 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		return;
#line 370 "game-series.c"
	}
#line 96 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp2_ = self->priv->undo_num_rounds;
#line 96 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->num_rounds = _tmp2_;
#line 97 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	memcpy (self->num_wins, self->priv->undo_num_wins, 2 * sizeof (gint));
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp4_ = pasang_game_get_stage ((PasangGame*) self);
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp5_ = _tmp4_;
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp5_ != PASANG_STAGE_SUB_MOVE) {
#line 384 "game-series.c"
		PasangStage _tmp6_ = 0;
		PasangStage _tmp7_ = 0;
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp6_ = pasang_game_get_stage ((PasangGame*) self);
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp7_ = _tmp6_;
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp3_ = _tmp7_ != PASANG_STAGE_SUB_SELECT;
#line 393 "game-series.c"
	} else {
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp3_ = FALSE;
#line 397 "game-series.c"
	}
#line 98 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	if (_tmp3_) {
#line 401 "game-series.c"
		gint _tmp8_ = 0;
#line 99 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		_tmp8_ = self->priv->recording_length1;
#line 99 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		self->priv->recording_length1 = _tmp8_ - 1;
#line 407 "game-series.c"
	}
#line 102 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp9_ = self->priv->recording;
#line 102 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp9__length1 = self->priv->recording_length1;
#line 102 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp10_ = _tmp9_[0];
#line 102 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	pasang_game_start ((PasangGame*) self, _tmp10_);
#line 417 "game-series.c"
	{
		gint i = 0;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
		i = 1;
#line 422 "game-series.c"
		{
			gboolean _tmp11_ = FALSE;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			_tmp11_ = TRUE;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
			while (TRUE) {
#line 429 "game-series.c"
				gint _tmp13_ = 0;
				gchar** _tmp14_ = NULL;
				gint _tmp14__length1 = 0;
				gchar** _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				gint _tmp16_ = 0;
				const gchar* _tmp17_ = NULL;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				if (!_tmp11_) {
#line 439 "game-series.c"
					gint _tmp12_ = 0;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
					_tmp12_ = i;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
					i = _tmp12_ + 1;
#line 445 "game-series.c"
				}
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp11_ = FALSE;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp13_ = i;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp14_ = self->priv->recording;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp14__length1 = self->priv->recording_length1;
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				if (!(_tmp13_ < _tmp14__length1)) {
#line 103 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
					break;
#line 459 "game-series.c"
				}
#line 104 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				pasang_game_generate_moves ((PasangGame*) self);
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp15_ = self->priv->recording;
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp15__length1 = self->priv->recording_length1;
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp16_ = i;
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				_tmp17_ = _tmp15_[_tmp16_];
#line 105 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
				pasang_game_perform_from_notation ((PasangGame*) self, _tmp17_);
#line 473 "game-series.c"
			}
		}
	}
}


/**
     * Return the starting pattern used to start the game
     */
gchar* pasang_game_series_starting_pattern (PasangGameSeries* self) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 112 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = self->priv->recording;
#line 113 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0__length1 = self->priv->recording_length1;
#line 113 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_vala_assert (_tmp0__length1 > 0, "recording.length > 0");
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1_ = self->priv->recording;
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp1__length1 = self->priv->recording_length1;
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp2_ = _tmp1_[0];
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	result = _tmp3_;
#line 114 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	return result;
#line 511 "game-series.c"
}


PasangGameSeries* pasang_game_series_construct (GType object_type) {
	PasangGameSeries * self = NULL;
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self = (PasangGameSeries*) pasang_game_construct (object_type);
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	return self;
#line 521 "game-series.c"
}


PasangGameSeries* pasang_game_series_new (void) {
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	return pasang_game_series_construct (PASANG_TYPE_GAME_SERIES);
#line 528 "game-series.c"
}


static void pasang_game_series_class_init (PasangGameSeriesClass * klass) {
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	pasang_game_series_parent_class = g_type_class_peek_parent (klass);
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	g_type_class_add_private (klass, sizeof (PasangGameSeriesPrivate));
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	G_OBJECT_CLASS (klass)->finalize = pasang_game_series_finalize;
#line 539 "game-series.c"
}


static void pasang_game_series_instance_init (PasangGameSeries * self) {
	gchar** _tmp0_ = NULL;
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv = PASANG_GAME_SERIES_GET_PRIVATE (self);
#line 42 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 42 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording = _tmp0_;
#line 42 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording_length1 = 0;
#line 42 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->_recording_size_ = self->priv->recording_length1;
#line 555 "game-series.c"
}


static void pasang_game_series_finalize (GObject* obj) {
	PasangGameSeries * self;
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PASANG_TYPE_GAME_SERIES, PasangGameSeries);
#line 42 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	self->priv->recording = (_vala_array_free (self->priv->recording, self->priv->recording_length1, (GDestroyNotify) g_free), NULL);
#line 24 "/home/jaidi/project/pasang-emas-active/pasang-emas-vala/src/game-series.vala"
	G_OBJECT_CLASS (pasang_game_series_parent_class)->finalize (obj);
#line 567 "game-series.c"
}


/**
 * Extends Game to support undo and keep track of the number of wins
 */
GType pasang_game_series_get_type (void) {
	static volatile gsize pasang_game_series_type_id__volatile = 0;
	if (g_once_init_enter (&pasang_game_series_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PasangGameSeriesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pasang_game_series_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PasangGameSeries), 0, (GInstanceInitFunc) pasang_game_series_instance_init, NULL };
		GType pasang_game_series_type_id;
		pasang_game_series_type_id = g_type_register_static (PASANG_TYPE_GAME, "PasangGameSeries", &g_define_type_info, 0);
		g_once_init_leave (&pasang_game_series_type_id__volatile, pasang_game_series_type_id);
	}
	return pasang_game_series_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



